package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.BannerInfo;
import com.izouma.awesomeadmin.service.BannerInfoService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/bannerInfo")
public class BannerInfoController extends BaseController{

    @Autowired
    private BannerInfoService bannerInfoService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(BannerInfo record) {
        List<BannerInfo> pp = bannerInfoService.getBannerInfoList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getBannerInfo", method = RequestMethod.GET)
    @ResponseBody
    public Result getBannerInfo(@RequestParam(required = false, value = "id") String id) {
        BannerInfo data = bannerInfoService.getBannerInfoById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(BannerInfo record) {
        BannerInfo data = bannerInfoService.getBannerInfo(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, BannerInfo record) {
        Map<String, Object> result = new HashMap<>();

        List<BannerInfo> pp =bannerInfoService.getBannerInfoByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(BannerInfo record) {
        boolean num = bannerInfoService.createBannerInfo(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateBannerInfo(BannerInfo record) {
        boolean num = bannerInfoService.updateBannerInfo(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteBannerInfo(@RequestParam(required = true, value = "id") String id) {

        boolean num = bannerInfoService.deleteBannerInfo(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, BannerInfo record) throws Exception {

    List<BannerInfo> bannerInfos = bannerInfoService.getBannerInfoList(record);


        String sheetName = "banner_info";
        String titleName = "首页banner数据表";
        String fileName = "首页banner表";
        int columnNumber = 9;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "标题" ,   "副标题" ,   "图片" ,   "链接" ,   "排序" ,   "热度" ,   "备注"  };
        String[][] dataList = new String[bannerInfos.size()][9];

        for (int i = 0; i < bannerInfos.size(); i++) {

                        dataList[i][0] = String.valueOf(bannerInfos.get(i).getId());
                        dataList[i][1] = String.valueOf(bannerInfos.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(bannerInfos.get(i).getTitle());
                        dataList[i][3] = String.valueOf(bannerInfos.get(i).getSubtitle());
                        dataList[i][4] = String.valueOf(bannerInfos.get(i).getImage());
                        dataList[i][5] = String.valueOf(bannerInfos.get(i).getNewsUrl());
                        dataList[i][6] = String.valueOf(bannerInfos.get(i).getRank());
                        dataList[i][7] = String.valueOf(bannerInfos.get(i).getHot());
                        dataList[i][8] = String.valueOf(bannerInfos.get(i).getRemark());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

